SystemOrganization addCategory: #'StyleProfile-Basic-Locator'!
SystemOrganization addCategory: #'StyleProfile-WebApp'!
SystemOrganization addCategory: #'StyleProfile-Tests-WebApp'!
SystemOrganization addCategory: #'StyleProfile-DAO'!
SystemOrganization addCategory: #'StyleProfile-Business-Model'!
SystemOrganization addCategory: #'StyleProfile-Tests-Basic-Locator'!
SystemOrganization addCategory: #'StyleProfile-Tests-DAO'!
SystemOrganization addCategory: #'StyleProfile-Tests-Business-Model'!

WAComponent subclass: #WeddingForm
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-WebApp'!

!WeddingForm class methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 01:29'!
initialize
    WAAdmin register: self asApplicationAt: 'wedform'! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 01:21'!
countries
    ^ #(#UnitedStates #China #India #France)! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 01:30'!
initialize
   super initialize.! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 01:20'!
renderAddressInputOn: html
	html
		tableRow: [ 
					html
						tableData: [ html text: 'Street Address: ' ];
						tableData: [ html textInput on: #street of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'City: ' ];
						tableData: [ html textInput on: #city of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'County: ' ];
						tableData: [ html textInput on: #county of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'State: ' ];
						tableData: [ html textInput on: #state of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'Zip Code: ' ];
						tableData: [ html textInput on: #zipcode of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'Country: ' ];
						tableData: [ 
									html select
										list: self countries;
										callback: [ :value | self user country: value ] ] ]! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 00:49'!
renderButtonsOn: html
	html
		tableData;
		tableData: [ html submitButton on: #save of: self ].! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 00:47'!
renderContentOn: html
	html div
		class: 'generic lightbox';
		with: [ 
					html heading: 'Basic information'.
					html
						form: [ 
							html
								table: [ 
									html
										tableRow: [ self renderNameInputOn: html ];
										tableRow: [ self renderAddressInputOn: html ];
										tableRow: [ self renderButtonsOn: html ] ] ] ]	"
Age*: 
Gender*: radio button
Education Level*: drop-down

Wedding Date:
Estimated Budget:"! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 01:16'!
renderNameInputOn: html
	html
		tableRow: [ 
					html
						tableData: [ html text: 'FirstName: ' ];
						tableData: [ html textInput on: #firstName of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'LastName: ' ];
						tableData: [ html textInput on: #lastName of: self user ] ];
		tableRow: [ 
					html
						tableData: [ html text: 'Email: ' ];
						tableData: [ html textInput on: #email of: self user ] ]! !

!WeddingForm methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 00:50'!
save
    "For now let's just display the contact information"
    self inform: self user name , '--' , self user country! !

!WeddingForm methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 01:05'!
user
	^ user ifNil: [ user := User createSampleUser ]
! !

!WeddingForm methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:54'!
user: anObject
	user := anObject! !

TestCase subclass: #CategoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Tests-Business-Model'!

!CategoryTest methodsFor: 'tests' stamp: 'IgorArouca 3/24/2013 23:10'!
createFloralCategory

	^ Category newName: #floral description: 'This category is about flowers'! !

!CategoryTest methodsFor: 'tests' stamp: 'IgorArouca 3/24/2013 23:10'!
testCreation

	| floral |

	floral := self createFloralCategory.

	self assert: floral name equals: 'floral'.
	self assert: floral description equals: 'This category is about flowers'! !

!CategoryTest methodsFor: 'tests' stamp: 'IgorArouca 3/24/2013 23:49'!
testCreationDuplicateError

	self createFloralCategory.	

	self should: [ Category newName: #floral description: 'This is a duplicate category' ]
		 raise: Error
		 description: 'A category named #floral already exists'
! !

TestCase subclass: #ConnectionServiceLocatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Tests-Basic-Locator'!

!ConnectionServiceLocatorTest methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 20:36'!
connectionSettings

	| settingsDict settingsStream tempStream |

	settingsDict := Dictionary new
		at: #host put: '127.0.0.1';
		at: #port put: '3306';
		at: #database put: 'information_schema';
		at: #user put: 'root';
		at: #password put: '';
		yourself.

	tempStream := String new writeStream.
	settingsDict storeOn: tempStream.

	^ ReadStream on: tempStream contents
! !

!ConnectionServiceLocatorTest methodsFor: 'tests' stamp: 'IgorArouca 3/23/2013 20:54'!
testConnection

	| strategy connection locator result |

	strategy := DBXManualConnectionStrategy newConnectionSettings: self connectionSettings.

	"Sets the default service to connect to the database above"
	locator := ConnectionServiceLocator instance connectionStrategy: strategy.

	"The returned connection is eady to receive queries to be executed agains the db"
	connection := locator connection.

	"Runs a simple query to test connection"
	result := connection execute: 'select * from engines'.

	self assert: result rows isEmpty equals: false. 

	"Closes the connection to release allocated resources"
	connection close
! !

!ConnectionServiceLocatorTest methodsFor: 'tests' stamp: 'IgorArouca 3/23/2013 21:07'!
testConnectionWithoutStrategy

	| locator |

	locator := ConnectionServiceLocator instance.
	locator connectionStrategy: nil.

	self should: [ locator connection ] raise: Error
! !

TestCase subclass: #PictureDAOTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Tests-DAO'!

!PictureDAOTest methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 12:24'!
testInstatiation

 
! !

TestCase subclass: #StyleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Tests-Business-Model'!

!StyleTest methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 13:00'!
testCreation

	| style |

	style := Style newName: 's' description: '' category: Category new.
	self assert: style name equals: 'd '.
	self assert: style description equals: 's'.! !

!StyleTest methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 12:34'!
testCreationWithoutNameAndDescription

	self should: [ Style new ] raise: Error
! !

Object subclass: #BaseDAO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-DAO'!

!BaseDAO methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 21:11'!
connection

	^ ConnectionServiceLocator instance connection
! !

BaseDAO subclass: #PictureDAO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-DAO'!

Object subclass: #Category
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Business-Model'!

!Category class methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 13:20'!
newName: aName description: aDescription

	^ super new privateName: aName description: aDescription
! !

!Category methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 23:50'!
checkIfNameIsUnique: aName

	((self class all collect: [ :category | category name ]) includes: aName) ifTrue: [ ^ self ]

	self error: 'A category named ', aName, ' alredy exists.'
! !

!Category methodsFor: 'accessing' stamp: 'HamidJahani 3/24/2013 14:44'!
description 
	^ description ! !

!Category methodsFor: 'accessing' stamp: 'HamidJahani 3/24/2013 14:44'!
name
	^ name! !

!Category methodsFor: 'private' stamp: 'IgorArouca 3/24/2013 23:39'!
privateName: aName

	aName isEmptyOrNil ifTrue: [ ^ self error: 'A category needs a name' ].

	self checkIfNameIsUnique: aName.

	name := aName asSymbol
! !

!Category methodsFor: 'private' stamp: 'HamidJahani 3/24/2013 14:42'!
privateName: aName description: aDescription

	self privateName: aName.
	description := aDescription
! !

Object subclass: #ConnectionServiceLocator
	instanceVariableNames: 'connectionStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Basic-Locator'!

ConnectionServiceLocator class
	instanceVariableNames: 'uniqueInstance connectionSettings'!

ConnectionServiceLocator class
	instanceVariableNames: 'uniqueInstance connectionSettings'!

!ConnectionServiceLocator class methodsFor: 'instance creation' stamp: 'IgorArouca 3/14/2013 08:58'!
instance

	^ uniqueInstance ifNil: [ uniqueInstance := self basicNew initialize ]
! !

!ConnectionServiceLocator class methodsFor: 'instance creation' stamp: 'IgorArouca 3/14/2013 08:59'!
new

	^ self shouldNotImplement
! !

!ConnectionServiceLocator methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:47'!
connection

	connectionStrategy ifNil: [
		^ self error: 'Please use the #connectionStrategy: method to tell me how I should get a connection for you'
	].

	^ connectionStrategy connection
! !

!ConnectionServiceLocator methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:16'!
connectionStrategy: aConnectionStrategy

	connectionStrategy := aConnectionStrategy
! !

Object subclass: #ConnectionStrategy
	instanceVariableNames: 'connectionSettings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Basic-Locator'!

!ConnectionStrategy class methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 18:33'!
newConnectionSettings: aStream

	^ super new connectionSettings: (self privateRetrieveConnectionSettingsDictionaryFrom: aStream)
! !

!ConnectionStrategy class methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 20:27'!
privateRetrieveConnectionSettingsDictionaryFrom: aStream
	"This method encapsulates the reading operation from the stream, which should follow the format defined by the input file used to store the connecion settings"
	
	^ Dictionary readFrom: aStream
! !

!ConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 16:48'!
connection

	^ self subclassResponsibility
! !

!ConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 18:28'!
connectionSettings: aDictionary

	connectionSettings := aDictionary
! !

ConnectionStrategy subclass: #DBXManualConnectionStrategy
	instanceVariableNames: 'service'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Basic-Locator'!

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 21:17'!
connection

	| connection |

	connection := DBXConnection platform: DBXMySQLBackend new settings: self connectionSettings.
	connection connect.
	connection reOpen.

	^ connection
! !

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:55'!
connectionSettings

	^ DBXConnectionSettings
		host: self host
		port: self port
		database: self database
		userName: self user
		userPassword: self password
! !

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:53'!
database

	^ connectionSettings at: #database
! !

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:53'!
host

	^ connectionSettings at: #host
! !

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:53'!
password

	^ connectionSettings at: #password
! !

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:54'!
port

	^ connectionSettings at: #port
! !

!DBXManualConnectionStrategy methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/23/2013 19:54'!
user

	^ connectionSettings at: #database
! !

Object subclass: #Style
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Business-Model'!

!Style class methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 12:33'!
new

	^ self error: 'I need a name and description. Please use method #newName:descroption: instead.'
! !

!Style class methodsFor: 'as yet unclassified' stamp: 'IgorArouca 3/24/2013 13:01'!
newName: aName description: aDescription category: aCategory

! !

Object subclass: #User
	instanceVariableNames: 'firstName lastName email street city county state zipcode country'
	classVariableNames: 'sampleUser'
	poolDictionaries: ''
	category: 'StyleProfile-WebApp'!

!User commentStamp: 'HamidJahani 4/1/2013 01:27' prior: 0!
This class should be moved to business model.

Instance Variables:
	firstName	<ProtoObject>
	lastName	<ProtoObject>
	email	<ProtoObject>
	street	<ProtoObject>
	city	<ProtoObject>
	county	<ProtoObject>
	state	<ProtoObject>
	zipcode	<ProtoObject>
	country	<ProtoObject>!

!User class methodsFor: 'as yet unclassified' stamp: 'HamidJahani 4/1/2013 01:10'!
createSampleUser
	^ self new
		firstName: 'Hamid';
		email: 'jahanim1@illinois.edu';
		yourself
		
	"firstName lastName email street city county state zipcode country"! !

!User class methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 01:07'!
sampleUser
	^ sampleUser! !

!User class methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 01:07'!
sampleUser: anObject
	sampleUser := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
city
	^ city! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
city: anObject
	city := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:05'!
country
	^ country! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:05'!
country: anObject
	country := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
county
	^ county! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
county: anObject
	county := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:03'!
email
	^ email! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:03'!
email: anObject
	email := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:03'!
firstName
	^ firstName! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:03'!
firstName: anObject
	firstName := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:03'!
lastName
	^ lastName! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:03'!
lastName: anObject
	lastName := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
state
	^ state! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
state: anObject
	state := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
street
	^ street! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:04'!
street: anObject
	street := anObject! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:05'!
zipcode
	^ zipcode! !

!User methodsFor: 'accessing' stamp: 'HamidJahani 4/1/2013 00:05'!
zipcode: anObject
	zipcode := anObject! !

Object subclass: #WeddingFormTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StyleProfile-Tests-WebApp'!
WeddingForm initialize!
